
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>java.util.AbstractStringBuilder源码分析 / 憋错料</title>

    <meta name="description" content="java.util.AbstractStringBuilder源码分析 AbstractStringBuilder是一个抽象类,是StringBuilder和StringBuffer的父类,分析它的源码对StringBuilder和StringBuffer代码的理解有很大的帮助. 先来看看该类的声明: abstract class AbstractStringBuilder implements Appendable, CharSequence {} 该类实现Appendable和CharSequence接口. 成员变量: char[] value;//字符数组用来">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">java.util.AbstractStringBuilder源码分析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>AbstractStringBuilder是一个抽象类，是StringBuilder和StringBuffer的父类，分析它的源码对StringBuilder和StringBuffer代码的理解有很大的帮助。</p>
<p>先来看看该类的声明：</p>
<pre>abstract class AbstractStringBuilder implements Appendable, CharSequence {}</pre>
<p>该类实现Appendable和CharSequence接口。</p>
<p>成员变量：</p>
<pre>char[] value;//字符数组用来存储字符串
int count;//值是字符串数组被使用的长度。注意，字符数组被使用长度不等于字符数组长度</pre>
<p>构造器：</p>
<pre>AbstractStringBuilder() {//无参构造器
}

AbstractStringBuilder(int capacity) {//带一个int参数构造器，capacity是字符串数组的大小，相当于字符串容器的大小
        value = new char[capacity];
}</pre>
<p>方法：</p>
<pre>//返回字符串实际大小public int length() {
        return count;
}
//返回容器容量
public int capacity() {
        return value.length;
}
//确保容器的大小比minimumCapcipty大
public void ensureCapacity(int minimumCapacity) {
        if (minimumCapacity &gt; 0)
            ensureCapacityInternal(minimumCapacity);
}

private void ensureCapacityInternal(int minimumCapacity) {
        // overflow-conscious code
        if (minimumCapacity - value.length &gt; 0)//如果minimumCapacity比容器大
            expandCapacity(minimumCapacity);//扩容
}

void expandCapacity(int minimumCapacity) {
        int newCapacity = value.length * 2 + 2;//新容量是(原容量大小+1)*2
        if (newCapacity - minimumCapacity &lt; 0)//如果扩容后仍然不够minimumCapacity
            newCapacity = minimumCapacity;//那么新容量就是minimumCapacity
        if (newCapacity &lt; 0) {
            if (minimumCapacity &lt; 0) // overflow
                throw new OutOfMemoryError();
            newCapacity = Integer.MAX_VALUE;
        }
        value = Arrays.copyOf(value, newCapacity);//创建新容器
}
//这个方法是让容器的大小变成跟字符串大小一样
public void trimToSize() {
        if (count &lt; value.length) {
            value = Arrays.copyOf(value, count);
        }
}
//设置字符串的长度，如果比原来长，多出来的部分填充‘\0‘，如果比原来短，截断
public void setLength(int newLength) {
        if (newLength &lt; 0)
            throw new StringIndexOutOfBoundsException(newLength);
        ensureCapacityInternal(newLength);

        if (count &lt; newLength) {
            Arrays.fill(value, count, newLength, ‘\0‘);
        }

        count = newLength;
}
//返回index位置的字符
public char charAt(int index) {
        if ((index &lt; 0) || (index &gt;= count))
            throw new StringIndexOutOfBoundsException(index);
        return value[index];
}
//注意下面的append方法，重载的方法很多，支持各种类型参数的append，仅列出部分//在字符串末尾添加一个字符串，该字符串由obj的toString方法决定
public AbstractStringBuilder append(Object obj) {
        return append(String.valueOf(obj));
}
//在字符串末尾添加一个字符串str
public AbstractStringBuilder append(String str) {
        if (str == null)
            return appendNull();
        int len = str.length();
        ensureCapacityInternal(count + len);
        str.getChars(0, len, value, count);
        count += len;
        return this;
}
//在字符串后面添加null字符串
private AbstractStringBuilder appendNull() {
        int c = count;
        ensureCapacityInternal(c + 4);
        final char[] value = this.value;
        value[c++] = ‘n‘;
        value[c++] = ‘u‘;
        value[c++] = ‘l‘;
        value[c++] = ‘l‘;
        count = c;
        return this;
}
//删除start至end的字符子串，容量不变，字符串长度减少end-start
public AbstractStringBuilder delete(int start, int end) {
        if (start &lt; 0)
            throw new StringIndexOutOfBoundsException(start);
        if (end &gt; count)
            end = count;
        if (start &gt; end)
            throw new StringIndexOutOfBoundsException();
        int len = end - start;
        if (len &gt; 0) {
            System.arraycopy(value, start+len, value, start, count-end);
            count -= len;
        }
}
//返回start至end的子串
public String substring(int start, int end) {
        if (start &lt; 0)
            throw new StringIndexOutOfBoundsException(start);
        if (end &gt; count)
            throw new StringIndexOutOfBoundsException(end);
        if (start &gt; end)
            throw new StringIndexOutOfBoundsException(end - start);　　　　return new String(value, start, end - start);
}
//在index位置插入str从offset开始，长度为len的子串
public AbstractStringBuilder insert(int index, char[] str, int offset,
                                        int len)
    {
        if ((index &lt; 0) || (index &gt; length()))
            throw new StringIndexOutOfBoundsException(index);
        if ((offset &lt; 0) || (len &lt; 0) || (offset &gt; str.length - len))
            throw new StringIndexOutOfBoundsException(
                "offset " + offset + ", len " + len + ", str.length "
                + str.length);
        ensureCapacityInternal(count + len);
        System.arraycopy(value, index, value, index + len, count - index);
        System.arraycopy(str, offset, value, index, len);
        count += len;
}
//将字符串的顺序颠倒，如"abc" reverse 成 "cba"
public AbstractStringBuilder reverse() {
        boolean hasSurrogates = false;
        int n = count - 1;
        for (int j = (n-1) &gt;&gt; 1; j &gt;= 0; j--) {
            int k = n - j;
            char cj = value[j];
            char ck = value[k];
            value[j] = ck;
            value[k] = cj;
            if (Character.isSurrogate(cj) ||
                Character.isSurrogate(ck)) {
                hasSurrogates = true;
            }
        }
        if (hasSurrogates) {
            reverseAllValidSurrogatePairs();
        }
        return this;
}

//...还有其他的方法</pre>
<p>可以看到AbstractStringBuilder几乎定义了所有字符串的操作，同时它接受任意类型的拼接，在一个动态数组上操作字符串，对于频繁的字符操作，相比于直接使用String来操作new一个新的String，能提高效率。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 13:47:47 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>java.util.AbstractStringBuilder源码分析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02mWGnM.html" rel="bookmark">java&period;util&period;TreeSet源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				public class TreeSet&lt;E&gt; extends AbstractSet&lt;E&gt; implements NavigableSet&lt;E&gt;, Cloneable, java.io.Serializable TreeSet的实现基于TreeMap,元素的顺序取决于元素自然顺序或者在被创建出来时提供的比较器. 对于基本操作,add.remove.contains的时间复杂度为logn. 不是线程安全的,如果在多线程环境下,必须被同步化,可通过一个object作为锁来			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vZjZg3.html" rel="bookmark">java&period;util&period;ArrayList源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				public class ArrayList&lt;E&gt; extends AbstractList&lt;E&gt; implements List&lt;E&gt;, RandomAccess, Cloneable, java.io.Serializable 可变数组大小的List实现,允许所有的元素,包括null.(该类可粗略地看作是Vector,除了它不是同步化的) size.isEmpty.get.set.iterator和listIterator操作的运行时间是常量.add操作对于添加n个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/ME8W7D4.html" rel="bookmark">java&period;util&period;HashSet源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				public class HashSet&lt;E&gt; extends AbstractSet&lt;E&gt; implements Set&lt;E&gt;, Cloneable, java.io.Serializable HashSet实现Set接口,内部维护一个HashMap实例变量.不保证顺序,允许null元素. 对于基本的操作,如add,remove,contains,size,只需要常量的时间复杂度. 不是线程安全的,如果在多线程环境下,需要被同步化,如调用方法Collections.s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmoRKD3.html" rel="bookmark">java&period;util&period;Map源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				/** * An object that maps keys to values. A map cannot contain duplicate keys; * each key can map to at most one value. * * &lt;p&gt;This interface takes the place of the &lt;tt&gt;Dictionary&lt;/tt&gt; class, which * was a totally abstract class rather t			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/47KRmY4.html" rel="bookmark">java&period;util&period;TreeMap源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				TreeMap的实现基于红黑树,排列的顺序根据key的大小,或者在创建时提供的比较器,取决于使用哪个构造器. 对于,containsKey,get,put,remove操作,保证时间复杂度为log(n). TreeMap的顺序与equals方法保持一致,这样才能遵守Map和SortMap的约定. 实现非同步,运行在多线程环境下,要进行外部同步,或者调用SortedMap m = Collections.synchronizedSortedMap(new TreeMap(...));方法得到一个同			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4186Ev3.html" rel="bookmark">java&period;io&period;BufferedOutputStream 源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				BufferedOutputStream  是一个带缓冲区到输出流,通过设置这种输出流,应用程序就可以将各个字节写入底层输出流中,而不必针对每次字节写入调用底层系统. 俩个成员变量,一个是存储数据的内部缓冲区,一个是缓冲区中的有效字节数. /** * The internal buffer where data is stored. */ protected byte buf[]; /** * The number of valid bytes in the buffer. This value			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Qqwee4.html" rel="bookmark">Java split方法源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java split方法源码分析 1 public String[] split(CharSequence input [, int limit]) { 2 int index = 0; // 指针 3 boolean matchLimited = limit &gt; 0; // 是否限制匹配个数 4 ArrayList&lt;String&gt; matchList = new ArrayList&lt;String&gt;(); // 匹配结果队列 5 Matcher m = matcher(inp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xGVBNM.html" rel="bookmark">【JAVA】ThreadLocal源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ThreadLocal内部是用一张哈希表来存储: 1 static class ThreadLocalMap { 2 static class Entry extends WeakReference&lt;ThreadLocal&lt;?&gt;&gt; { 3 /** The value associated with this ThreadLocal. */ 4 Object value; 5 6 Entry(ThreadLocal&lt;?&gt; k, Object v) { 7 super(k)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Q0xJln4.html" rel="bookmark">Java并发包源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				并发是一种能并行运行多个程序或并行运行一个程序中多个部分的能力.如果程序中一个耗时的任务能以异步或并行的方式运行,那么整个程序的吞吐量和可交互性将大大改善.现代的PC都有多个CPU或一个CPU中有多个核,是否能合理运用多核的能力将成为一个大规模应用程序的关键. Java基础部分知识总结点击Java并发基础总结.Java多线程相关类的实现都在Java的并发包concurrent,concurrent包主要包含3部分内容,第一个是atomic包,里面主要是一些原子类,比如AtomicInteger.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0awyPn4.html" rel="bookmark" class="title">（28）初识struts框架</a>
					<div>
						案例剖析中介绍了一个自己写的mystruts框架,这里开始简单的认识struts框架. 1.先看一个简单的struts开发的例子来熟悉一下流程 Struts就是基于mvc模式的框架! (struts其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41gbbg0.html" rel="bookmark" class="title">A child container failed during start 解决方案</a>
					<div>
						症状:A child container failed during start 适用问题描述:tomcat挂空可以正常运行,载入项目时挂掉. 相关操作:之前为了省事,由于两个servlet功能类似所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZYklq0.html" rel="bookmark" class="title">HDU2296 Ring（AC自动机&plus;DP）</a>
					<div>
						题目是给几个带有价值的单词.而一个字符串的价值是 各单词在它里面出现次数*单词价值 的和,问长度不超过n的最大价值的字符串是什么? 依然是入门的AC自动机+DP题..不一样的是这题要输出具体方案,加个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLjl1d3.html" rel="bookmark" class="title">Pytnon学习之路-基础知识1</a>
					<div>
						永远的Hello World! print(&quot;Hello World!&quot;) &gt;&gt;Hello World! 数据类型 Number类型: 数值类型,用于存储数字 Inte ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47mKZY0.html" rel="bookmark" class="title">基于IP-SAN的存储Linux挂载</a>
					<div>
						1.卸载原有存储 umount /home/weishaostore/ 2.查看iSCSI session信息 iscsiadm -m session 3.设置InitiatorName vim /e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Jydp93.html" rel="bookmark" class="title">炼闪墒墒肿敌缴度</a>
					<div>
						http://my.oschina.net/fclllu5 http://my.oschina.net/vubzbr1 http://my.oschina.net/tzmyiea3 http://my ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bqR1pM.html" rel="bookmark" class="title">sarafi浏览器iframe跨域cookie无效的处理方案&lpar;笨方法，看官莫笑&rpar;</a>
					<div>
						&lt;script&gt; $(function(){ url = 'oauth_authorize_api'; loaded = false; iframe = '&lt;iframe id=&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qEB893.html" rel="bookmark" class="title">幽灵按钮</a>
					<div>
						&lt;!DOCTYPE html&gt;&lt;html xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt;&lt;head&gt;    &lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lew8W3.html" rel="bookmark" class="title">efsdsdfgsrtyruhfgdasdfasa</a>
					<div>
						http://pp.163.com/forum/359001/subject/4340317/ http://pp.163.com/forum/359001/subject/4337852/ http ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lkQ9EM.html" rel="bookmark" class="title">vim末行模式</a>
					<div>
						(1) 地址定界 :start_pos[,end_pos] #:特定的第#行,例如5即第5行: .:当前行: $:最后一行: #,#:指定行范围,左侧为起始行,右侧为结束行: #,+#:指定行范围,左 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0koqYb0.html" rel="bookmark" class="title">基于Pipe的PureMVC FLEX框架的多核共享消息技术</a>
					<div>
						pipes utilities,也就是所谓的通道(管道),为什么要使用通道呢?模块的结构都是一个单独的puremvc结构,模块和模块,shell和模块之间的通信 不能使用puremvc中的消息进行,因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWVGvk4.html" rel="bookmark" class="title">mono-project</a>
					<div>
						http://download.mono-project.com/sources/libgdiplus/libgdiplus-4.2.tar.gz http://download.mono-proje ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoL6wy0.html" rel="bookmark" class="title">机房收费系统重构之策略模式</a>
					<div>
						一.前言 前面我们学习了23种设计模式,不过一直没用过,这次机房重构就是让我们将学习的这些理论应用与实践.首先,机房收费的主要功能就是上机收费,一说的收费就会有针对普通用户和会员等,实行不同的收费方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGArbV3.html" rel="bookmark" class="title">express结合jade模板渲染HTML</a>
					<div>
						注意:以下是在Windwo环境下 运行: npm install jade 然后你的目录node_modules下将增加jade文件夹 app.js var express=require(&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6Xn1Z3.html" rel="bookmark" class="title">Python爬取猫眼top100排行榜数据【含多线程】</a>
					<div>
						# -*- coding: utf-8 -*- import requests from multiprocessing import Pool from requests.exceptions im ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEjblK0.html" rel="bookmark" class="title">Android实例-IdHTTP下载&lpar;并实现自动安装&rpar;&lpar;XE10&plus;小米2&rpar;</a>
					<div>
						http://www.cnblogs.com/FKdelphi/p/5416941.html Android实例-IdHTTP下载(并实现自动安装)(XE10+小米2) 相关资料: 1.群号 3836 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVRXypM.html" rel="bookmark" class="title">【ERROR】使用jquery的ajax出现error&colon;readyState&equals;4&comma;status&equals;500</a>
					<div>
						使用jquery的ajax出现error:readyState=4,status=500,ajax代码如下: $.ajax({ url : &quot;../toBeFinMisManage/show ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38kB5A0.html" rel="bookmark" class="title">js中bind，call，apply方法的应用</a>
					<div>
						最近用js的类写东西,发现一个无比蛋疼的事,那就是封装的类方法中的this指针经常会改变指向,失去上下文,导致程序错误或崩溃. 比如: function Obj(){ this.type = &quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXGmgb4.html" rel="bookmark" class="title">系统中《员工管理》设计参考</a>
					<div>
						RDIFramework.NET ━ .NET快速信息化系统开发框架 9.2  员工管理 -Web部分 员工(职员)管理主要是对集团.企事业内部员工进行管理.在后面的章节可以看到有一个用户管理,这两者 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzDDel3.html" rel="bookmark" class="title">Python之Python Imaging Library</a>
					<div>
						from PIL import Image 1.打开图片 img = Image.open(fileName) 2.保存图片 img.save(imgName) 3.调整图片大小 def resize ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
